OSSL_PARAM_DUP(3ossl)

NAME
OSSL_PARAM_dup, OSSL_PARAM_merge, OSSL_PARAM_free - OSSL_PARAM array copy functions

SYNOPSIS
 #include <openssl/params.h>

 OSSL_PARAM *OSSL_PARAM_dup(const OSSL_PARAM *params);
 OSSL_PARAM *OSSL_PARAM_merge(const OSSL_PARAM *params, const OSSL_PARAM *params1);
 void OSSL_PARAM_free(OSSL_PARAM *params);

DESCRIPTION
Algorithm parameters can be exported/imported from/to providers using arrays of OSSL_PARAM(3). The following utility functions allow the parameters to be duplicated and merged with other OSSL_PARAM(3) to assist in this process.

OSSL_PARAM_dup() duplicates the parameter array params. This function does a deep copy of the data.

OSSL_PARAM_merge() merges the parameter arrays params and params1 into a new parameter array. If params and params1 contain values with the same 'key' then the value from params1 will replace the param value. This function does a shallow copy of the parameters. Either params or params1 may be NULL. The behaviour of the merge is unpredictable if params and params1 contain the same key, and there are multiple entries within either array that have the same key.

OSSL_PARAM_free() frees the parameter array params that was created using OSSL_PARAM_dup(), OSSL_PARAM_merge() or OSSL_PARAM_BLD_to_param(). If the argument to OSSL_PARAM_free() is NULL, nothing is done.

RETURN VALUES
The functions OSSL_PARAM_dup() and OSSL_PARAM_merge() return a newly allocated OSSL_PARAM(3) array, or NULL if there was an error. If both parameters are NULL then NULL is returned.

SEE ALSO
OSSL_PARAM(3), OSSL_PARAM_BLD(3)

HISTORY
The functions were added in OpenSSL 3.0.

COPYRIGHT
Copyright 2021-2024 The OpenSSL Project Authors. All Rights Reserved.

Licensed under the Apache License 2.0 (the "License"). You may not use this file except in compliance with the License. You can obtain a copy in the file LICENSE in the source distribution or at <https://www.openssl.org/source/license.html>.